## ncbi-vdb 2.11.2+dfsg

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = test/kfs

include $(TOP)/build/Makefile.env
RWORKDIR = $(TOP)/$(MODULE)

INT_TOOLS = \
	test-sysfs \
	test-buffile \
	ktartest \
	test-pagefile \
	test-kpath-read-path \
	test-bzip-concat \
	test-sysfile-timeout \
	test-headfile


TEST_TOOLS = \
	test-kfs \
	test-ramfile \
	test-resolve

ifneq (win,$(OS))
	INT_TOOLS += test-kfsmanager
endif

# sparse file is automagic in unix so no testing
ifeq (win,$(OS))
	TEST_TOOLS += test-sparse
endif

EXT_TOOLS =

ALL_TOOLS = \
	$(INT_TOOLS) \
	$(EXT_TOOLS) \
	$(TEST_TOOLS)

RWORKDIR = $(BINDIR)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(ALL_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: all std $(ALL_TOOLS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(TEST_BINDIR)/,$(ALL_TOOLS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean 
	@ rm -f $(addsuffix *,$(addprefix $(TEST_BINDIR)/,$(ALL_TOOLS)))

.PHONY: clean

#-------------------------------------------------------------------------------
# tag
#
tag: \
	$(addsuffix _tag,$(ALL_TOOLS))

.PHONY: tag $(addsuffix _tag,$(ALL_TOOLS))

#-------------------------------------------------------------------------------
# test os-native file system
#
TEST_SYSFS_SRC = \
	test-sysfs

TEST_SYSFS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_SYSFS_SRC))

TEST_SYSFS_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/test-sysfs: $(TEST_SYSFS_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_SYSFS_LIB)

#-------------------------------------------------------------------------------
# test buffered file
#
TEST_BUFFILE_SRC = \
	test-buffile

TEST_BUFFILE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_BUFFILE_SRC))

TEST_BUFFILE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/test-buffile: $(TEST_BUFFILE_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_BUFFILE_LIB)


#-------------------------------------------------------------------------------
# test tar component of KFS - gives us our view of a tar file
#
KTARTEST_SRC = \
	ktartest

KTARTEST_OBJ = \
	$(addsuffix .$(OBJX),$(KTARTEST_SRC))

KTARTEST_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/ktartest: $(KTARTEST_OBJ)
	$(LD) --exe -o $@ $^ $(KTARTEST_LIB)


#-------------------------------------------------------------------------------
# test pagefile
#
TEST_PAGEFILE_SRC = \
	test-pagefile

TEST_PAGEFILE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_PAGEFILE_SRC))

TEST_PAGEFILE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/test-pagefile: $(TEST_PAGEFILE_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_PAGEFILE_LIB)


#-------------------------------------------------------------------------------
# test test-kpath-read-path
#
TEST_KPATH_READ_PATH_SRC = \
	test-kpath-read-path

TEST_KPATH_READ_PATH_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_KPATH_READ_PATH_SRC))

TEST_KPATH_READ_PATH_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/test-kpath-read-path: $(TEST_KPATH_READ_PATH_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_KPATH_READ_PATH_LIB)

#-------------------------------------------------------------------------------
# test-bzip-concat
#
TEST_BZIP_CONCAT_SRC = \
	test-bzip-concat

TEST_BZIP_CONCAT_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_BZIP_CONCAT_SRC))

TEST_BZIP_CONCAT_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lbz2

$(TEST_BINDIR)/test-bzip-concat: $(TEST_BZIP_CONCAT_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_BZIP_CONCAT_LIB)

#-------------------------------------------------------------------------------
# test-sysfile-timeout
#
TEST_SYSFILE_TIMEOUT_SRC = \
	test-sysfile-timeout

TEST_SYSFILE_TIMEOUT_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_SYSFILE_TIMEOUT_SRC))

TEST_SYSFILE_TIMEOUT_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lbz2

$(TEST_BINDIR)/test-sysfile-timeout: $(TEST_SYSFILE_TIMEOUT_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_SYSFILE_TIMEOUT_LIB)

#-------------------------------------------------------------------------------
# test-kfsmanager
#
TEST_KFSMANAGER_SRC = \
	test-kfsmanager

TEST_KFSMANAGER_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_KFSMANAGER_SRC))

TEST_KFSMANAGER_LIB = \
	-lkapp \
	-lvfs \
	-lkrypto \
	-lkfg \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lbz2

$(TEST_BINDIR)/test-kfsmanager: $(TEST_KFSMANAGER_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_KFSMANAGER_LIB)


#-------------------------------------------------------------------------------
# test headfile
#
TEST_HEADFILE_SRC = \
	test-headfile

TEST_HEADFILE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_HEADFILE_SRC))

TEST_HEADFILE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-ldl \
	-lz \
	-lbz2

$(TEST_BINDIR)/test-headfile: $(TEST_HEADFILE_OBJ)
	$(LD) --exe -o $@ $^ $(TEST_HEADFILE_LIB)


#-------------------------------------------------------------------------------
# test-kfs
#
TEST_KFS_SRC = \
	kfstest 

TEST_KFS_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_KFS_SRC))

TEST_KFS_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-lktst

ifeq (linux,$(OS))
	TEST_KFS_LIB += -lkff -lmagic
endif

$(TEST_BINDIR)/test-kfs: $(TEST_KFS_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_KFS_LIB)

#-------------------------------------------------------------------------------
# test-ramfile
#
TEST_RAMFILE_SRC = \
	ramfiletest 

TEST_RAMFILE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_RAMFILE_SRC))

TEST_RAMFILE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-lktst

$(TEST_BINDIR)/test-ramfile: $(TEST_RAMFILE_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_RAMFILE_LIB)


#-------------------------------------------------------------------------------
# test-resolve
#
TEST_RESOLVE_SRC = \
	resolvetest 

TEST_RESOLVE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_RESOLVE_SRC))

TEST_RESOLVE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-lktst

$(TEST_BINDIR)/test-resolve: $(TEST_RESOLVE_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_RESOLVE_LIB)

#-------------------------------------------------------------------------------
# test-sparse
#
TEST_SPARSE_SRC = \
	sparsetest 

TEST_SPARSE_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_SPARSE_SRC))

TEST_SPARSE_LIB = \
	-lkapp \
	-lvfs \
	-lkfg \
	-lkrypto \
	-lkfs \
	-lkproc \
	-lklib \
	-lktst

$(TEST_BINDIR)/test-sparse: $(TEST_SPARSE_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_SPARSE_LIB)

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =       \
    vfs         \
    ktst        \
    cc          \
    ext         \
    judy_test   \
    kfc         \
    kfs         \
    klib        \
    kfg         \
    kapp        \
    cloud       \
    kdb         \
    kproc       \
    vdb         \
    search      \
    sraxf       \
    vxf         \
    loader      \
    krypto      \
    cipher      \
	ncbi-vdb    \
    ngs-python  \
    kns         \
    schema      \
    ngs-java    \
    install     \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

=== vdb3/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(ncbi-vdb3)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# determine OS
if ( ${CMAKE_HOST_SYSTEM_NAME} STREQUAL  "Darwin" )
    set(OS "mac")
elseif ( ${CMAKE_HOST_SYSTEM_NAME} STREQUAL  "Linux" )
    set(OS "linux")
elseif()
    message ( FATAL_ERROR "unknown OS " ${CMAKE_HOST_SYSTEM_NAME})
endif()

# determine architecture
if ( ${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "armv7l")
	set(ARCH "armv7l")
elseif ( ${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "aarch64")
    set(ARCH "aarch64")
elseif ( ${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "x86_64")
    set(ARCH "x86_64")
elseif()
    message ( FATAL_ERROR "unknown architecture " ${CMAKE_HOST_SYSTEM_PROCESSOR})
endif ()

# create variables based entirely upon OS
if ( "mac" STREQUAL ${OS} )
    add_definitions( -DMAC -DBSD -DUNIX )
elseif( "linux" STREQUAL ${OS} )
    add_definitions( -DLINUX -DUNIX )
    set( LMCHECK -lmcheck )
endif()

# create variables based entirely upon ARCH
if ("armv7l" STREQUAL ${ARCH})
	set( BITS 32 )
    add_definitions( -DRPI )
	add_compile_options( -mcpu=cortex-a53 -mfpu=neon-vfpv4 -Wno-psabi )
	set ( Z128SRC z128 )
	set ( Z128LSRC z128.nopt )
elseif ("aarch64" STREQUAL ${ARCH} )
	set ( BITS 64 )
	add_definitions( -DHAVE_Z128 )
elseif ("x86_64" STREQUAL ${ARCH} )
    set ( BITS 64 )
    add_definitions( -DHAVE_Z128 -DLONG_DOUBLE_IS_NOT_R128 )
endif()

# now any unique combinations of OS and ARCH
if     ( "mac-x86_84" STREQUAL ${OS}-${ARCH})
elseif ( "linux-x86_64" STREQUAL ${OS}-${ARCH})
    add_definitions( -DHAVE_R128 )
elseif ( "linux-armv7l" STREQUAL ${OS}-${ARCH})
elseif ( "linux-aarch64" STREQUAL ${OS}-${ARCH})
    add_definitions( -DHAVE_R128 -D__float128=_Float128 )
endif()

# combinations of OS and COMP
if ( ${OS}-${CMAKE_CXX_COMPILER_ID} STREQUAL "linux-GNU"  )
    add_definitions( -rdynamic )
endif()

# combinations of OS, ARCH and COMP
if ( ${OS}-${ARCH}-${CMAKE_CXX_COMPILER_ID} STREQUAL "linux-x86_64-GNU"  )
    add_definitions( -DHAVE_QUADMATH )
	set ( LQUADMATH -lquadmath )
elseif ( ${OS}-${ARCH}-${CMAKE_CXX_COMPILER_ID} STREQUAL "linux-x86_64-Clang"  )
endif()

add_definitions( -DARCHBITS=${BITS} -D${ARCH} -Wall )

if ( "${CMAKE_BUILD_TYPE}" STREQUAL "" )
    set ( CMAKE_BUILD_TYPE "Debug" )
endif()

if ( ${CMAKE_BUILD_TYPE} STREQUAL "Debug" )
    add_definitions( -DDEBUG )
endif()

#message( "OS=" ${OS} " ARCH=" ${ARCH} " CXX=" ${CMAKE_CXX_COMPILER} " LMCHECK=" ${LMCHECK} "BITS=" ${BITS} )

include_directories(external/googletest/googletest/include)
include_directories(external)
include_directories(interfaces)
include_directories(inc)

# testing
enable_testing()
set(GTEST_LIBRARIES gtest )

add_subdirectory(external)
add_subdirectory(platform)
add_subdirectory(tests)

# documentation
find_package(Doxygen)
if ( Doxygen_FOUND )
    # set DOXYGEN_* variables here
    doxygen_add_docs(docs interfaces)
endif()

=== vdb3/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default all std: makedirs cmake

TOP ?= $(abspath $(CURDIR)/..)

include $(TOP)/build/Makefile.env

cmake:
	mkdir -p $(TARGDIR)/vdb3; cd $(TARGDIR)/vdb3; cmake $(CMAKEFLAGS) $(TOP)/vdb3
	+ make -C $(TARGDIR)/vdb3 -j$(MAKE_JOBS)

clean: stdclean
	@ if [ -d $(TARGDIR)/vdb3 ] ; then make -C $(TARGDIR)/vdb3 clean; rm -rf $(TARGDIR)/vdb3; fi

ctest: cmake
	cd $(TARGDIR)/vdb3; ctest $(CMAKEFLAGS) $(CTESTARGS) --verbose

test runtests: ctest

.PHONY: clean cmake ctest

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/align

INT_LIBS = \
	libncbi-bam \
	libalign-writer \
	libalign-access \
	libsam-extract \
	libalign-reader

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =              \
	$(BAM_OBJ)          \
	$(ALIGN_ACCESS_OBJ) \
	$(ALIGN_READER_OBJ) \
	$(ALIGN_WRITER_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# libncbi-bam
#
$(ILIBDIR)/libncbi-bam: $(addprefix $(ILIBDIR)/libncbi-bam.,$(ILIBEXT))

BAM_SRC = \
	bam

BAM_OBJ = \
	$(addsuffix .$(LOBX),$(BAM_SRC))

BAM_LIB =

$(ILIBDIR)/libncbi-bam.$(LIBX): $(BAM_OBJ)
	$(LD) --slib -o $@ $^ $(BAM_LIB)


#-------------------------------------------------------------------------------
# align-access
#
$(ILIBDIR)/libalign-access: $(addprefix $(ILIBDIR)/libalign-access.,$(ILIBEXT))

ALIGN_ACCESS_SRC = \
	align-access

ALIGN_ACCESS_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_ACCESS_SRC))

ALIGN_ACCESS_LIB =

$(ILIBDIR)/libalign-access.$(LIBX): $(ALIGN_ACCESS_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_ACCESS_LIB)

#-------------------------------------------------------------------------------
# align-reader
#
$(ILIBDIR)/libalign-reader: $(addprefix $(ILIBDIR)/libalign-reader.,$(ILIBEXT))

ALIGN_READER_SRC = \
	align_mgr \
	al_iterator \
	unsupported_pileup_estimator \
	ref_iterator \
	pl_iterator \
	dna-reverse-cmpl \
	reference-cmn \
	reader-cmn \
	reader-refseq \
	reader-wgs \
	reference \
	refseq-mgr \
	quality-quantizer

ALIGN_READER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_READER_SRC))

ALIGN_READER_LIB =

$(ILIBDIR)/libalign-reader.$(LIBX): $(ALIGN_READER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_READER_LIB)

#-------------------------------------------------------------------------------
# align-writer
#
$(ILIBDIR)/libalign-writer: $(addprefix $(ILIBDIR)/libalign-writer.,$(LIBX))

ALIGN_WRITER_SRC = \
    dna-reverse-cmpl \
	reader-cmn \
	reference-cmn \
	reader-refseq \
	reader-wgs \
	refseq-mgr \
	writer-cmn \
	writer-refseq \
	writer-alignment \
	writer-sequence \
	writer-ref \
	writer-reference

ALIGN_WRITER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_WRITER_SRC))

ALIGN_WRITER_LIB =

$(ILIBDIR)/libalign-writer.$(LIBX): $(ALIGN_WRITER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_WRITER_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# samextract
#
$(ILIBDIR)/libsam-extract: $(addprefix $(ILIBDIR)/libsam-extract.,$(LIBX))

SAM_EXTRACT_SRC = \
     samextract-grammar \
     samextract-lex \
     samextract-lib \
     samextract-bam \
     samextract-pool

SAM_EXTRACT_OBJ = \
	$(addsuffix .$(LOBX),$(SAM_EXTRACT_SRC))

SAM_EXTRACT_LIB =

bison:
	bison --no-lines -g -r all -Werror=all \
		-o $(SRCDIR)/samextract-grammar.c \
	--defines=$(SRCDIR)/samextract-tokens.h \
	-v -Wall --no-lines \
	$(SRCDIR)/samextract-grammar.y

ifeq (dbg,$(BUILD))
  FLEX_DEBUG=-d
endif

flex:
	flex --noline --fast -v -p $(FLEX_DEBUG) \
		-o $(SRCDIR)/samextract-lex.c \
		-DYY_BUF_SIZE=16777216 \
		$(SRCDIR)/samextract-lex.l

$(ILIBDIR)/libsam-extract.$(LIBX): $(SAM_EXTRACT_OBJ)
	$(LD) --slib -o $@ $^ $(SAM_EXTRACT_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/ascp/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/ascp

INT_LIBS = \
    libascp

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# testing framework
#
$(ILIBDIR)/libascp: $(addprefix $(ILIBDIR)/libascp.,$(LIBX))

SRC = \
	ascp \
	ascp-path \
	connect
#	silent-system

OBJ = \
	$(addsuffix .$(LOBX),$(SRC))

$(ILIBDIR)/libascp.$(LIBX): $(OBJ)
	$(LD) --slib -o $@ $^ $(LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/kapp/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/kapp

include $(TOP)/build/Makefile.env

INT_LIBS = \
	libkapp \
	libkapp-norsrc \
    libload

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KAPP_OBJ) \
	$(KAPPR_OBJ) \
	$(LOADLIB_OBJ)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# OS specific application support
#
$(ILIBDIR)/libkapp: $(addprefix $(ILIBDIR)/libkapp.,$(LIBX))

KAPP_CMN = \
	args \
	args-conv \
	args-conv-os \
	tokenizer \
	sysmain \
	ram \
	log-xml

KAPP_SRC = \
	main \
	$(KAPP_CMN)

KAPP_OBJ = \
	$(addsuffix .$(OBJX),$(KAPP_SRC))

KAPP_LIB = \
	-dvfs \
	-dklib

$(ILIBDIR)/libkapp.$(LIBX): $(KAPP_OBJ)
	$(LD) --slib -o $@ $^ $(KAPP_LIB)


#-------------------------------------------------------------------------------
# KMane without KRsrc support
#
$(ILIBDIR)/libkapp-norsrc: $(addprefix $(ILIBDIR)/libkapp-norsrc.,$(LIBX))

KAPPR_SRC = \
	main-norsrc \
	$(KAPP_CMN)

main-norsrc.$(OBJX): main.c
	$(CC) -o $@ $(OPT) -DNO_KRSRC=1 $< $(LOC_INFO) -D__file_ext__=c

KAPPR_OBJ = \
	$(addsuffix .$(OBJX),$(KAPPR_SRC))

KAPPR_LIB = \

$(ILIBDIR)/libkapp-norsrc.$(LIBX): $(KAPPR_OBJ)
	$(LD) --slib -o $@ $^ $(KAPPR_LIB)


#-------------------------------------------------------------------------------
# loaders common libarary
#
$(ILIBDIR)/libload: $(addprefix $(ILIBDIR)/libload.,$(LIBX))

LOADLIB_SRC = \
	progressbar \
	loader-file \
	loader-meta

ifneq (win,$(OS))
	LOADLIB_SRC += queue-file
endif

LOADLIB_OBJ = \
	$(addsuffix .$(LOBX),$(LOADLIB_SRC))

LOADLIB_LIB = \
	-dkfs \
	-dklib

ifneq (win,$(OS))
	LOADLIB_LIB += -dkq
endif

$(ILIBDIR)/libload.$(LIBX): $(LOADLIB_OBJ)
	$(LD) --slib -o $@ $^ $(LOADLIB_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/kdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/kdb

INT_LIBS = \
	libkdb \
	libwkdb

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KDB_OBJ) \
	$(WKDB_OBJ)

include $(TOP)/build/Makefile.env

DEFINES += -DUSE_BSTREE_IN_COLUMN_IDX1


#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS) $(ALL_DEFS)


#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kdb
#
$(ILIBDIR)/libkdb: $(addprefix $(ILIBDIR)/libkdb.,$(ILIBEXT))

KDB_CMN = \
	btree \
	rowset \
	rowset-simple \
	dbmgr-cmn \
#	database-cmn

KDB_SRC = \
	$(KDB_CMN) \
	kdb \
	dbmgr \
	dbcc-cmn \
	database \
	database-cc \
	table \
	table-cc \
	column \
	column-cc \
	coldata \
	colidx \
	colidx0 \
	colidx1 \
	colidx2 \
	idxblk \
	meta \
	index \
	idstats \
	trieidx-v1 \
	trieval-v1 \
	ptrieval-v1 \
	trieidx-v2 \
	trieval-v2 \
	ptrieval-v2 \
	u64idx-v3

KDB_OBJ = \
	$(addsuffix .$(LOBX),$(KDB_SRC))

KDB_LIB = \
	-dvfs \
	-dkrypto \
	-dkfs \
	-dklib

$(ILIBDIR)/libkdb.$(LIBX): $(KDB_OBJ)
	$(LD) --slib -o $@ $^ $(KDB_LIB)


#-------------------------------------------------------------------------------
# wkdb
#
$(ILIBDIR)/libwkdb: $(addprefix $(ILIBDIR)/libwkdb.,$(ILIBEXT))

WKDB_SRC = \
	$(KDB_CMN) \
	wkdb \
	wdbmgr \
	wdatabase \
	wtable \
	wcolumn \
	wcoldata \
	wcolidx \
	wcolidx0 \
	wcolidx1 \
	wcolidx2 \
	idxblk \
	widxblk \
	wmeta \
	windex \
	wtrieidx-v1 \
	wtrieidx-v2 \
	wu64idx-v3

WKDB_OBJ = \
	$(addsuffix .$(LOBX),$(WKDB_SRC))

WKDB_LIB = \
	-dvfs \
	-dkrypto \
	-dkfs \
	-dklib

$(ILIBDIR)/libwkdb.$(LIBX): $(WKDB_OBJ)
	$(LD) --slib -o $@ $^ $(WKDB_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/kfc/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/kfc

INT_LIBS = \
	libkfc

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KFC_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/all

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kfc
#
$(ILIBDIR)/libkfc: $(addprefix $(ILIBDIR)/libkfc.,$(ILIBEXT))

KFC_SRC = \
	refcount \
	tstate \
	sysrsrc \
	rsrc \
	vtbl \
	sysctx \
	except \
	xc \

KFC_OBJ = \
	$(addsuffix .$(LOBX),$(KFC_SRC))

KFC_LIB = \

$(ILIBDIR)/libkfc.$(LIBX): $(KFC_OBJ)
	$(LD) --slib -o $@ $^ $(KFC_LIB)


compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)


#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(abspath ../..)
MODULE = libs/kfs

INT_LIBS = \
	libkfs \
	libkfs-nommap \
	libkff \

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =           \
	$(KFS_OBJ)       \
	$(KFS_NOMMAP_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# mmap.c
#  special rule to generate a disabled mmap
#
%.nommap.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -DFORCE_MALLOC_MMAP -D_LIBRARY $<


#-------------------------------------------------------------------------------
# kfs
#
$(ILIBDIR)/libkfs: $(addprefix $(ILIBDIR)/libkfs.,$(ILIBEXT))

$(ILIBDIR)/libkfs-nommap: $(addprefix $(ILIBDIR)/libkfs-nommap.,$(LIBX))

KFS_CMN = \
	directory \
	arrayfile \
	file \
	chunk-reader \
	sysdir \
	sysfile \
	sysmmap \
	syslockfile \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-read \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem \
	readheadfile \
	ramfile \
	extendable-ramfile \
	quickmount \
	report \
	lockfile \
	remove-file-task \
	syslockfile \
	cacheteefile \
	cacheteefile2 \
	cacheteefile3 \
	rrcachedfile \
	recorder \
	logfile \
	callback_file \
	poolpages \
	lru_cache \
	from_to_namelist \
	limitfile   \
	appendfile

KFS_SRC = \
	mmap \
	$(KFS_CMN)

ifeq (win,$(OS))
	KFS_SRC += directory-path
endif

KFS_NOMMAP_SRC = \
	mmap.nommap \
	$(KFS_CMN)

KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_NOMMAP_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_NOMMAP_SRC))

KFS_LIB = \
	-dkproc \
	-dklib \
	-ddl \
	-dz \
	-dbz2

#	-dsz \

$(ILIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)

$(ILIBDIR)/libkfs-nommap.$(LIBX): $(KFS_NOMMAP_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)



#-------------------------------------------------------------------------------
# kfs.2
#
$(ILIBDIR)/libkfs.2: $(addprefix $(ILIBDIR)/libkfs.2.,$(ILIBEXT))

KFS2_SRC = \
	$(KFS_SRC) \
	file-v2 \
	directory-v2 \
	sysfile-v2
#	sysdir-v2

KFS2_OBJ = \
	$(addsuffix .$(LOBX),$(KFS2_SRC))

KFS2_LIB = \
	$(KFS_LIB)

$(ILIBDIR)/libkfs.2.$(LIBX): $(KFS2_OBJ)
	$(LD) --slib -o $@ $^ $(KFS2_LIB)


#-------------------------------------------------------------------------------
# kff
#
ifeq (1,$(HAVE_MAGIC))

$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))

OBJFILES += $(KFF_OBJ)

KFF_SRC = \
	fileformat \
	ffext \
	ffkey \
	ffmagic

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dkfg \
	-dklib

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

else

$(ILIBDIR)/libkff:
	@ echo "NOTE - internal library $(@F) cannot be built:"         \
	       "It requires 'libmagic' and its development headers."

endif

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)


#-------------------------------------------------------------------------------
# fuzz
#
ifneq (1,$(HAVE_MAGIC))
INT_LIBS = \
	libkfs \
	libkfs-nommap
endif

fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/klib

INT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KLIB_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy all
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all $(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ $(MAKE) -C $(SRCDIR)/judy clean

.PHONY: clean

#-------------------------------------------------------------------------------
# klib
#
$(ILIBDIR)/libklib: $(addprefix $(ILIBDIR)/libklib.,$(ILIBEXT))

KLIB_SRC = \
	text \
	time \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	all-vdb-version \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	misc \
	SHA-32bit \
	SHA-64bit \
	qsort \
	ksort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syserrcode \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	systime \
	rc-tbl \
	rc-idx-tbl \
	judy-vector \
	report-klib \
	num-gen \
	progressbar \
	sra-release-version \
	hashtable \
	hashfile \
	btree \
	json \
	json-grammar \
	json-lex \
	base64 \
	guid
#	path

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
else
	KLIB_SRC += release
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \
	-sjudy \
	-lm

$(ILIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib -o $@ $^ $(KLIB_LIB)


# compilation
compile: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy compile
	@ $(MAKE_CMD) -j$(MAKE_JOBS) $(TARGDIR)/compile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# fuzz
#
FUZZ_OBJ = \
	$(addprefix $(OBJDIR)/,$(addsuffix .fuzz.$(LOBX),$(KLIB_SRC)))

fuzz: std $(FUZZ_OBJ)
	$(AR) $(FLIBDIR)/libklib.$(LIBX) $(FUZZ_OBJ)

#-------------------------------------------------------------------------------
#
# flex/bison for the Json parser
#
# Will not be executed in a regular build. Use 'make bison' and/or 'make flex' to re-generate C files
#

bison: $(SRCDIR)/json-grammar.y
	bison -Wno-other --no-lines -r state -o $(SRCDIR)/json-grammar.c --defines=$(SRCDIR)/json-tokens.h $(SRCDIR)/json-grammar.y

flex: $(SRCDIR)/json-lex.l $(SRCDIR)/json-tokens.h
	flex --noline -d -t $(SRCDIR)/json-lex.l > $(SRCDIR)/json-lex.c

=== libs/kns/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/kns

INT_LIBS = \
	libkns

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KNS_OBJ)

include $(TOP)/build/Makefile.env

RWORKDIR = $(TOP)/$(MODULE)

#-------------------------------------------------------------------------------
# outer targets
#

# we are building it on all platforms now, because dependency on libcurl is removed
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kns
#
$(ILIBDIR)/libkns: $(addprefix $(ILIBDIR)/libkns.,$(ILIBEXT))

KNS_NO_HTTP_SRC = \
	stream-from-buffer \
	kns_manager-ext \
	manager \
	proxy \
	stable-http-file \
	buffered-stream \
	stream \
	stream-from-files \
	stream-from-streams \
	endpoint \
	sysendpoint \
	syssock \
	sysstream \
	sysmgr \
	tls

ifneq (win,$(OS))
KNS_NO_HTTP_SRC += \
	syspoll
endif

KNS_SRC = \
	$(KNS_NO_HTTP_SRC) \
	http-file          \
	http-client        \
	http-request       \
	http-retrier       \
	http               \

KNS_OBJ = \
	$(addsuffix .$(LOBX),$(KNS_SRC))

KNS_LIB = \
    -lkfs \
	-dklib

$(ILIBDIR)/libkns.$(LIBX): $(KNS_OBJ)
	$(LD) --slib -o $@ $^ $(KNS_LIB)


compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# fuzz
#
fuzz: std
	cp $(addsuffix .$(LIBX),$(addprefix $(ILIBDIR)/,$(INT_LIBS))) $(FLIBDIR)/

=== debian/changelog ===
ncbi-vdb (2.11.2+dfsg-6) unstable; urgency=medium

  * Source-only reupload for testing migration.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 01 Sep 2022 21:33:23 -0400

ncbi-vdb (2.11.2+dfsg-5) unstable; urgency=medium

  * .gitignore: Also ignore libs/jni/jni(_md).h.
  * debian/.gitignore (new): Ignore generated files and subtrees.
  * debian/control:
    - Clean up descriptions.  In particular, use a modern synopsis cribbed
      from vdb3/README.md as a first paragraph across the board.
    - Note that all packages already qualify as Multi-Arch: same.
    - Introduce ncbi-vdb-data (M-A: foreign) and have libncbi-(w)vdb2
      depend on it.
  * debian/copyright:
    - Resync details with tarball contents.
    - Stop claiming Upstream-Name: ngs.
  * debian/ncbi-vdb-data.install: Rename from libncbi-vdb2.install.  (It
    listed only default configuration files, with d-shlibs taking care
    of the rest.)
  * debian/rules: Move schemata to ncbi-vdb-data, not libncbi-vdb2.
  * Standards-Version: 4.6.1 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 24 Aug 2022 14:26:20 -0400

ncbi-vdb (2.11.2+dfsg-4) unstable; urgency=medium

  * zstd.patch: Adopt dynamic system zstd more fully.
    - Comment out ZSTD_STATIC_LINKING_ONLY to enforce use of stable APIs.
    - Actually link libncbi-(w)vdb and libvdb-sqlite against libzstd.
  * Have libncbi-vdb2 break sra-toolkit (<< 2.11) anyway -- even with zstd
    linkage fixed, sra-toolkit 2.10.x's autopkgtest will still fail over
    dropped support for protected repository configuration.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 22 Nov 2021 22:39:27 -0500

ncbi-vdb (2.11.2+dfsg-3) unstable; urgency=medium

  * Leave mbedtls quirk handling to d-shlibs (>= 0.104).  (Closes: #999788.)
  * Skip VDB3, at least for now -- it FTBFS on i386, and has so far just
    been an uninstalled technology preview.
  * Enable arm64 builds.  To that end:
    - add_-msse2.patch: Limit -msse2 to 32-bit x86.  (Redundant on 64-bit
      x86, invalid elsewhere.)
    - debian/rules: Wildcard upstream architecture name (VDB_ARCH), no
      longer consistently aligned with any single dpkg-architecture variable.
  * debian/watch: Track tags rather than releases, of which GitHub no
    longer lists any(!).

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 20 Nov 2021 23:06:09 -0500

ncbi-vdb (2.11.2+dfsg-2) unstable; urgency=medium

  * Binary package libncbi-vdb-dev Depends: libzstd-dev

 -- Andreas Tille <tille@debian.org>  Mon, 01 Nov 2021 16:56:26 +0100

ncbi-vdb (2.11.2+dfsg-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Build-Depends: cmake
  * Use Debian packaged libzstd
  * Fix missing cstdlib include
  * Add more files to debian/not-installed
  * Drop RFCs from package source

 -- Andreas Tille <tille@debian.org>  Mon, 11 Oct 2021 14:16:45 +0200

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs (>= 0.104),
               cmake,
               libbz2-dev,
               libxml2-dev,
               libhdf5-dev,
               libmagic-dev,
               libngs-sdk-dev,
               libngs-java,
               libmbedtls-dev,
               zlib1g-dev,
               libzstd-dev,
               default-jdk-headless
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-vdb
Vcs-Git: https://salsa.debian.org/med-team/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb
Rules-Requires-Root: no

Package: libncbi-vdb2
Architecture: amd64 arm64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
	 ncbi-vdb-data (>= ${source:Version})
Breaks: sra-toolkit (<< 2.11~)
Multi-Arch: same
Description: libraries for using data in the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for reading VDB data.

Package: libncbi-vdb-dev
Architecture: amd64 arm64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb2 (= ${binary:Version}),
         libkdf5-dev (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         libzstd-dev,
         zlib1g-dev
Multi-Arch: same
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This is the development package for reading VDB data.

Package: ncbi-vdb-data
Architecture: all
Section: libs
Depends: ${misc:Depends}
Breaks: libncbi-vdb2 (<< 2.11.2+dfsg-5~), libncbi-vdb3 (<< 3.0.0+dfsg2)
Replaces: libncbi-vdb2 (<< 2.11.2+dfsg-5~), libncbi-vdb3 (<< 3.0.0+dfsg2)
Multi-Arch: foreign
Description: schemata and defaults for the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains VDB schemata for SRA data and default
 configuration files for VDB libraries.

Package: libkdf5-2
Architecture: amd64 arm64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmbedtls-dev
Multi-Arch: same
Description: hdf5 access to data in the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format, version 5 (HDF5).

Package: libkdf5-dev
Architecture: amd64 arm64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libkdf5-2 (= ${binary:Version})
Multi-Arch: same
Description: hdf5 access to data in the INSDC Sequence Read Archives (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).
 .
 This is the development package.

Package: libncbi-wvdb2
Architecture: amd64 arm64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
	 ncbi-vdb-data (>= ${source:Version})
Multi-Arch: same
Description: virtual layer update module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for updating VDB data.

Package: libncbi-wvdb-dev
Architecture: amd64 arm64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb2 (= ${binary:Version})
Multi-Arch: same
Description: virtual layer update module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains development files for updating VDB data.

Package: libvdb-sqlite2
Architecture: amd64 arm64 i386 x32
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: SQLite module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides an SQLite
 interface.

Package: libvdb-sqlite-dev
Architecture: amd64 arm64 i386 x32
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libvdb-sqlite2 (= ${binary:Version})
Multi-Arch: same
Description: SQLite module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains development files for an SQLite interface.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DH_BUILD_MAINT_OPTIONS := nocheck

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(DEB_SOURCE)/$(OS)/gcc
# VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
VDB_ARCH := *
LIBINSTALLDIR := debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/$(VDB_ARCH)/dbg/lib
SCHEMADIR := debian/ncbi-vdb-data/usr/lib/$(DEB_SOURCE)
DSLMFLAGS := --commit --multiarch --devunversioned --exclude-la

# See debian/patches/fix-linking
# export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEB_SOURCE)/$(MULTIARCH)
	rm -f libs/ngs-jni/jni.h
	rm -f libs/ngs-jni/jni_md.h
	rm -f build/ld.linux.exe_cmd.sh

override_dh_auto_configure:
	# that's no standard configure script lacking support of default options
	# The build system shamelessly ignores those options like
	#    --with-ngs-java-prefix=/usr/share/java
	# so we need to go with patches.  The options are specified anyway.
	ln -s /usr/lib/jvm/default-java/include/jni.h		libs/ngs-jni
	ln -s /usr/lib/jvm/default-java/include/linux/jni_md.h	libs/ngs-jni
	./configure --build=$(MULTIARCH) --prefix=/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr --with-debug --with-ngs-java-prefix=/usr/share/java
	# no idea how to convince configure script to use the correct include dir so patching result afterwards
	sed -i 's?HDF5_INCDIR = /usr/include?&/hdf5/serial?' build/Makefile.config*

override_dh_auto_build:
	dh_auto_build --no-parallel -- NO_VDB3=1
	# we need to make really sure that no 'vdb_'-prefixed functions will remain ...
	if find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep -q vdb_mbedtls ; then \
	    find . \( -name "*.so" -o -name "*.a" \) -exec strings \{\} \; | tee | grep vdb_mbedtls ; \
	    grep -Rl vdb_mbedtls  debian/tmp/* ; \
	    exit 1 ; \
	    false ; \
	fi

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test -- NO_VDB3=1 || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_prep:
	dh_prep -Xdebian/tmp

override_dh_auto_install:
	dh_auto_install -- NO_VDB3=1
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
	d-shlibmove $(DSLMFLAGS) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp-norsrc.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkff.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libktst.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxfs.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxml.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libload.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui_cpp.a usr/lib/$(MULTIARCH) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-vdb.so
	install -d debian/libncbi-vdb-dev/usr/include
	cp -a interfaces debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	# json-response.h and services-priv.h are needed by sra-sdk, but
	# the latter shouldn't replace interfaces/vfs/services-priv.h.
	dh_install -plibncbi-vdb-dev libs/vfs/json-response.h usr/include/ncbi-vdb/vfs
	cp libs/vfs/services-priv.h debian/libncbi-vdb-dev/usr/include/ncbi-vdb/vfs/services-priv-internal.h
	d-shlibmove $(DSLMFLAGS) \
		    --override s/libhdf5_serial[0-9]*-dev/libhdf5-dev/ \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libkdf5.so
	d-shlibmove $(DSLMFLAGS) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-wvdb.so
	d-shlibmove $(DSLMFLAGS) \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libvdb-sqlite.so
	find debian/lib* -name .gitignore -delete
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	set -x ; \
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    sed -i "s:^include ':&/usr/lib/ncbi-vdb/:" $${schema} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done

override_dh_missing:
	dh_missing --fail-missing
